Index: ntoskrnl/ps/process.c
===================================================================
--- ntoskrnl/ps/process.c	(revision 21808)
+++ ntoskrnl/ps/process.c	(working copy)
@@ -31,7 +31,7 @@
 
 NTSTATUS
 NTAPI
-PsLockProcess(PEPROCESS Process, BOOLEAN Timeout)
+PsLockProcess(PROS_EPROCESS Process, BOOLEAN Timeout)
 {
   ULONG Attempts = 0;
   PKTHREAD PrevLockOwner;
@@ -90,7 +90,7 @@
 
 VOID
 NTAPI
-PsUnlockProcess(PEPROCESS Process)
+PsUnlockProcess(PROS_EPROCESS Process)
 {
   PAGED_CODE();
 
@@ -288,7 +288,7 @@
                             ObjectAttributes,
                             PreviousMode,
                             NULL,
-                            sizeof(EPROCESS),
+                            sizeof(ROS_EPROCESS),
                             0,
                             0,
                             (PVOID*)&Process);
@@ -301,7 +301,7 @@
 
     /* Clean up the Object */
     DPRINT("Cleaning Process Object\n");
-    RtlZeroMemory(Process, sizeof(EPROCESS));
+    RtlZeroMemory(Process, sizeof(ROS_EPROCESS));
 
     /* Inherit stuff from the Parent since we now have the object created */
     if (pParentProcess)
@@ -325,7 +325,7 @@
 
     /* Setup the Lock Event */
     DPRINT("Initialzing Process Lock\n");
-    KeInitializeEvent(&Process->LockEvent, SynchronizationEvent, FALSE);
+    KeInitializeEvent(&((PROS_EPROCESS)Process)->LockEvent, SynchronizationEvent, FALSE);
 
     /* Setup the Thread List Head */
     DPRINT("Initialzing Process ThreadListHead\n");
@@ -338,8 +338,8 @@
 
     /* Set Process's Directory Base */
     DPRINT("Initialzing Process Directory Base\n");
-    MmCopyMmInfo(pParentProcess ? pParentProcess : PsInitialSystemProcess,
-                 Process,
+    MmCopyMmInfo((PROS_EPROCESS)(pParentProcess ? pParentProcess : PsInitialSystemProcess),
+                 (PROS_EPROCESS)Process,
                  &DirectoryTableBase);
 
     /* Now initialize the Kernel Process */
@@ -360,7 +360,7 @@
 
     /* Create the Process' Address Space */
     DPRINT("Initialzing Process Address Space\n");
-    Status = MmCreateProcessAddressSpace(Process, SectionObject);
+    Status = MmCreateProcessAddressSpace((PROS_EPROCESS)Process, (PROS_SECTION_OBJECT)SectionObject);
     if (!NT_SUCCESS(Status))
     {
         DPRINT1("Failed to create Address Space\n");
@@ -376,8 +376,8 @@
 
     /* Create a handle for the Process */
     DPRINT("Initialzing Process CID Handle\n");
-    CidEntry.u1.Object = Process;
-    CidEntry.u2.GrantedAccess = 0;
+    CidEntry.Object = Process;
+    CidEntry.GrantedAccess = 0;
     Process->UniqueProcessId = ExCreateHandle(PspCidTable, &CidEntry);
     DPRINT("Created CID: %d\n", Process->UniqueProcessId);
     if(!Process->UniqueProcessId)
@@ -393,7 +393,7 @@
     if (pParentProcess)
     {
         DPRINT("Creating PEB\n");
-        Status = MmCreatePeb(Process);
+        Status = MmCreatePeb((PROS_EPROCESS)Process);
         if (!NT_SUCCESS(Status))
         {
             DbgPrint("NtCreateProcess() Peb creation failed: Status %x\n",Status);
@@ -492,7 +492,7 @@
                                          ProcessId)))
     {
         /* Get the Process */
-        FoundProcess = CidEntry->u1.Object;
+        FoundProcess = CidEntry->Object;
 
         /* Make sure it's really a process */
         if (FoundProcess->Pcb.Header.Type == ProcessObject)
@@ -534,7 +534,7 @@
                                           Cid->UniqueThread)))
     {
         /* Get the Process */
-        FoundThread = CidEntry->u1.Object;
+        FoundThread = CidEntry->Object;
 
         /* Make sure it's really a thread and this process' */
         if ((FoundThread->Tcb.DispatcherHeader.Type == ThreadObject) &&
Index: ntoskrnl/ps/win32.c
===================================================================
--- ntoskrnl/ps/win32.c	(revision 21808)
+++ ntoskrnl/ps/win32.c	(working copy)
@@ -13,17 +13,18 @@
 #include <ntoskrnl.h>
 #define NDEBUG
 #include <internal/debug.h>
+#include <win32k/callout.h>
 
 /* GLOBALS ******************************************************************/
 
-static PW32_PROCESS_CALLBACK PspWin32ProcessCallback = NULL;
-static PW32_THREAD_CALLBACK PspWin32ThreadCallback = NULL;
+static PKWIN32_PROCESS_CALLOUT PspWin32ProcessCallback = NULL;
+static PKWIN32_THREAD_CALLOUT PspWin32ThreadCallback = NULL;
 
 extern OB_OPEN_METHOD ExpWindowStationObjectOpen;
-extern OB_PARSE_METHOD ExpWindowStationObjectParse;
+extern OB_ROS_PARSE_METHOD ExpWindowStationObjectParse;
 extern OB_DELETE_METHOD ExpWindowStationObjectDelete;
-extern OB_FIND_METHOD ExpWindowStationObjectFind;
-extern OB_CREATE_METHOD ExpDesktopObjectCreate;
+extern OB_ROS_FIND_METHOD ExpWindowStationObjectFind;
+extern OB_ROS_CREATE_METHOD ExpDesktopObjectCreate;
 extern OB_DELETE_METHOD ExpDesktopObjectDelete;
 
 #ifndef ALEX_CB_REWRITE
@@ -55,11 +56,12 @@
  */
 VOID 
 STDCALL
-PsEstablishWin32Callouts(PW32_CALLOUT_DATA CalloutData)
+PsEstablishWin32Callouts(PWIN32_CALLOUTS_FPNS calloutData)
 {
+    PW32_CALLOUT_DATA CalloutData = (PW32_CALLOUT_DATA)calloutData;
     PspWin32ProcessCallback = CalloutData->W32ProcessCallout;
     PspWin32ThreadCallback = CalloutData->W32ThreadCallout;
-    ExpWindowStationObjectOpen = CalloutData->WinStaCreate;
+    ExpWindowStationObjectOpen = CalloutData->WinStaOpen;
     ExpWindowStationObjectParse = CalloutData->WinStaParse;
     ExpWindowStationObjectDelete = CalloutData->WinStaDelete;
     ExpWindowStationObjectFind = CalloutData->WinStaFind;
Index: ntoskrnl/ps/query.c
===================================================================
--- ntoskrnl/ps/query.c	(revision 21808)
+++ ntoskrnl/ps/query.c	(working copy)
@@ -428,11 +428,11 @@
       case ProcessImageFileName:
       {
           ULONG ImagePathLen = 0;
-          PSECTION_OBJECT Section;
+          PROS_SECTION_OBJECT Section;
           PUNICODE_STRING DstPath = (PUNICODE_STRING)ProcessInformation;
           PWSTR SrcBuffer = NULL, DstBuffer = (PWSTR)(DstPath + 1);
 
-          Section = (PSECTION_OBJECT)Process->SectionObject;
+          Section = (PROS_SECTION_OBJECT)Process->SectionObject;
 
           if (Section != NULL && Section->FileObject != NULL)
           {
@@ -653,7 +653,7 @@
           {
             /* lock the process to be thread-safe! */
 
-            Status = PsLockProcess(Process, FALSE);
+            Status = PsLockProcess((PROS_EPROCESS)Process, FALSE);
             if(NT_SUCCESS(Status))
             {
               /*
@@ -671,7 +671,7 @@
                 ObDereferenceObject(ExceptionPort);
                 Status = STATUS_PORT_ALREADY_SET;
               }
-              PsUnlockProcess(Process);
+              PsUnlockProcess((PROS_EPROCESS)Process);
             }
             else
             {
@@ -758,7 +758,7 @@
 
           /* FIXME - update the session id for the process token */
 
-          Status = PsLockProcess(Process, FALSE);
+          Status = PsLockProcess((PROS_EPROCESS)Process, FALSE);
           if(NT_SUCCESS(Status))
           {
             Process->Session = SessionInfo.SessionId;
@@ -785,7 +785,7 @@
               KeDetachProcess();
             }
 
-            PsUnlockProcess(Process);
+            PsUnlockProcess((PROS_EPROCESS)Process);
           }
         }
         break;
Index: ntoskrnl/ps/thread.c
===================================================================
--- ntoskrnl/ps/thread.c	(revision 21808)
+++ ntoskrnl/ps/thread.c	(working copy)
@@ -182,8 +182,8 @@
 
     /* Create Cid Handle */
     DPRINT("Creating Thread Handle (CID)\n");
-    CidEntry.u1.Object = Thread;
-    CidEntry.u2.GrantedAccess = 0;
+    CidEntry.Object = Thread;
+    CidEntry.GrantedAccess = 0;
     Thread->Cid.UniqueThread = ExCreateHandle(PspCidTable, &CidEntry);
     if (!Thread->Cid.UniqueThread) {
 
@@ -220,7 +220,7 @@
 
         /* Create Teb */
         DPRINT("Initialliazing Thread PEB\n");
-        TebBase = MmCreateTeb(Process, &Thread->Cid, InitialTeb);
+        TebBase = MmCreateTeb((PROS_EPROCESS)Process, &Thread->Cid, InitialTeb);
 
         /* Set the Start Addresses */
         DPRINT("Initialliazing Thread Start Addresses :%x, %x\n", ThreadContext->Eip, ThreadContext->Eax);
@@ -378,7 +378,7 @@
                                          ThreadId)))
     {
         /* Get the Process */
-        FoundThread = CidEntry->u1.Object;
+        FoundThread = CidEntry->Object;
 
         /* Make sure it's really a process */
         if (FoundThread->Tcb.DispatcherHeader.Type == ThreadObject)
Index: ntoskrnl/ps/psmgr.c
===================================================================
--- ntoskrnl/ps/psmgr.c	(revision 21808)
+++ ntoskrnl/ps/psmgr.c	(working copy)
@@ -154,7 +154,7 @@
    RtlZeroMemory(&ObjectTypeInitializer, sizeof(ObjectTypeInitializer));
    RtlInitUnicodeString(&Name, L"Process");
    ObjectTypeInitializer.Length = sizeof(ObjectTypeInitializer);
-   ObjectTypeInitializer.DefaultNonPagedPoolCharge = sizeof(EPROCESS);
+   ObjectTypeInitializer.DefaultNonPagedPoolCharge = sizeof(ROS_EPROCESS);
    ObjectTypeInitializer.GenericMapping = PiProcessMapping;
    ObjectTypeInitializer.PoolType = NonPagedPool;
    ObjectTypeInitializer.ValidAccessMask = PROCESS_ALL_ACCESS;
@@ -181,7 +181,7 @@
 			   NULL,
 			   KernelMode,
 			   NULL,
-			   sizeof(EPROCESS),
+			   sizeof(ROS_EPROCESS),
 			   0,
 			   0,
 			   (PVOID*)&PsIdleProcess);
@@ -192,7 +192,7 @@
         return;
      }
 
-   RtlZeroMemory(PsIdleProcess, sizeof(EPROCESS));
+   RtlZeroMemory(PsIdleProcess, sizeof(ROS_EPROCESS));
 
    PsIdleProcess->Pcb.Affinity = 0xFFFFFFFF;
    PsIdleProcess->Pcb.IopmOffset = 0xffff;
@@ -203,7 +203,7 @@
    InitializeListHead(&PsIdleProcess->ActiveProcessLinks);
    KeInitializeDispatcherHeader(&PsIdleProcess->Pcb.Header,
 				ProcessObject,
-				sizeof(EPROCESS) / sizeof(LONG),
+				sizeof(ROS_EPROCESS) / sizeof(LONG),
 				FALSE);
    PsIdleProcess->Pcb.DirectoryTableBase.QuadPart = (ULONG_PTR)MmGetPageDirectory();
    strcpy(PsIdleProcess->ImageFileName, "Idle");
@@ -217,7 +217,7 @@
 			   NULL,
 			   KernelMode,
 			   NULL,
-			   sizeof(EPROCESS),
+			   sizeof(ROS_EPROCESS),
 			   0,
 			   0,
 			   (PVOID*)&PsInitialSystemProcess);
@@ -229,7 +229,7 @@
      }
 
    /* System threads may run on any processor. */
-   RtlZeroMemory(PsInitialSystemProcess, sizeof(EPROCESS));
+   RtlZeroMemory(PsInitialSystemProcess, sizeof(ROS_EPROCESS));
 #ifdef CONFIG_SMP   
    /* FIXME:
     *   Only the boot cpu is initialized. Threads of the 
@@ -245,15 +245,15 @@
    InitializeListHead(&PsInitialSystemProcess->Pcb.ThreadListHead);
    KeInitializeDispatcherHeader(&PsInitialSystemProcess->Pcb.Header,
 				ProcessObject,
-				sizeof(EPROCESS) / sizeof(LONG),
+				sizeof(ROS_EPROCESS) / sizeof(LONG),
 				FALSE);
    KProcess = &PsInitialSystemProcess->Pcb;
    PspInheritQuota(PsInitialSystemProcess, NULL);
 
-   MmInitializeAddressSpace(PsInitialSystemProcess,
-			    &PsInitialSystemProcess->AddressSpace);
+   MmInitializeAddressSpace((PROS_EPROCESS)PsInitialSystemProcess,
+			    &((PROS_EPROCESS)PsInitialSystemProcess)->AddressSpace);
 
-   KeInitializeEvent(&PsInitialSystemProcess->LockEvent, SynchronizationEvent, FALSE);
+   KeInitializeEvent(&((PROS_EPROCESS)PsInitialSystemProcess)->LockEvent, SynchronizationEvent, FALSE);
 
 #if defined(__GNUC__)
    KProcess->DirectoryTableBase =
@@ -300,8 +300,8 @@
   ObCreateHandleTable(NULL, FALSE, PsInitialSystemProcess);
   ObpKernelHandleTable = PsInitialSystemProcess->ObjectTable;
 
-  CidEntry.u1.Object = PsInitialSystemProcess;
-  CidEntry.u2.GrantedAccess = 0;
+  CidEntry.Object = PsInitialSystemProcess;
+  CidEntry.GrantedAccess = 0;
   PsInitialSystemProcess->UniqueProcessId = ExCreateHandle(PspCidTable, &CidEntry);
 
   if(!PsInitialSystemProcess->UniqueProcessId)
Index: ntoskrnl/ps/job.c
===================================================================
--- ntoskrnl/ps/job.c	(revision 21808)
+++ ntoskrnl/ps/job.c	(working copy)
@@ -157,7 +157,7 @@
                 /* lock the process so we can safely assign the process. Note that in the
                 meanwhile another thread could have assigned this process to a job! */
 
-                Status = PsLockProcess(Process, FALSE);
+                Status = PsLockProcess((PROS_EPROCESS)Process, FALSE);
                 if(NT_SUCCESS(Status))
                 {
                     if(Process->Job == NULL && Process->Session == Job->SessionId)
@@ -173,7 +173,7 @@
                         /* process is already assigned to a job or session id differs! */
                         Status = STATUS_ACCESS_DENIED;
                     }
-                    PsUnlockProcess(Process);
+                    PsUnlockProcess((PROS_EPROCESS)Process);
 
                     if(NT_SUCCESS(Status))
                     {
Index: ntoskrnl/ps/kill.c
===================================================================
--- ntoskrnl/ps/kill.c	(revision 21808)
+++ ntoskrnl/ps/kill.c	(working copy)
@@ -166,7 +166,7 @@
     SeDeassignPrimaryToken(Process);
 
     /* Release Memory Information */
-    MmReleaseMmInfo(Process);
+    MmReleaseMmInfo((PROS_EPROCESS)Process);
 
     /* Delete the W32PROCESS structure if there's one associated */
     if(Process->Win32Process != NULL) ExFreePool(Process->Win32Process);
@@ -240,7 +240,7 @@
     KeLowerIrql(PASSIVE_LEVEL);
 
     /* Lock the Process before we modify its thread entries */
-    PsLockProcess(CurrentProcess, FALSE);
+    PsLockProcess((PROS_EPROCESS)CurrentProcess, FALSE);
 
     /* wake up the thread so we don't deadlock on PsLockProcess */
     KeForceResumeThread(&CurrentThread->Tcb);
@@ -308,7 +308,7 @@
         }
         
         DPRINT("Decommit teb at %p\n", Teb);
-        MmDeleteTeb(CurrentProcess, Teb);
+        MmDeleteTeb((PROS_EPROCESS)CurrentProcess, Teb);
         CurrentThread->Tcb.Teb = NULL;
     }
 
@@ -316,7 +316,7 @@
     if (Last) PspExitProcess(CurrentProcess);
 
     /* Unlock the Process */
-    PsUnlockProcess(CurrentProcess);
+    PsUnlockProcess((PROS_EPROCESS)CurrentProcess);
 
     /* Cancel I/O for the thread. */
     IoCancelThreadIo(CurrentThread);
@@ -563,11 +563,11 @@
 
     CurrentThread = PsGetCurrentThread();
 
-    PsLockProcess(Process, FALSE);
+    PsLockProcess((PROS_EPROCESS)Process, FALSE);
 
     if(Process->ExitTime.QuadPart != 0)
     {
-      PsUnlockProcess(Process);
+      PsUnlockProcess((PROS_EPROCESS)Process);
       ObDereferenceObject(Process);
       return STATUS_PROCESS_IS_TERMINATING;
     }
@@ -592,7 +592,7 @@
                unlocking the process, fail */
             CurrentThread->Terminated = TRUE;
 
-            PsUnlockProcess(Process);
+            PsUnlockProcess((PROS_EPROCESS)Process);
 
             /* we can safely dereference the process because the current thread
                holds a reference to it until it gets reaped */
@@ -610,7 +610,7 @@
     }
 
     /* unlock and dereference the process so the threads can kill themselves */
-    PsUnlockProcess(Process);
+    PsUnlockProcess((PROS_EPROCESS)Process);
     ObDereferenceObject(Process);
 
     return(STATUS_SUCCESS);
@@ -668,7 +668,7 @@
     if (Thread != PsGetCurrentThread())  {
 
         /* we need to lock the process to make sure it's not already terminating */
-        PsLockProcess(Thread->ThreadsProcess, FALSE);
+        PsLockProcess((PROS_EPROCESS)Thread->ThreadsProcess, FALSE);
 
         /* This isn't our thread, terminate it if not already done */
         if (!Thread->Terminated) {
@@ -679,7 +679,7 @@
              PspTerminateThreadByPointer(Thread, ExitStatus);
         }
 
-        PsUnlockProcess(Thread->ThreadsProcess);
+        PsUnlockProcess((PROS_EPROCESS)Thread->ThreadsProcess);
 
         /* Dereference the Thread and return */
         ObDereferenceObject(Thread);
Index: ntoskrnl/include/ntoskrnl.h
===================================================================
--- ntoskrnl/include/ntoskrnl.h	(revision 21808)
+++ ntoskrnl/include/ntoskrnl.h	(working copy)
@@ -16,6 +16,7 @@
 #include <ntddk.h>
 #include <ntifs.h>
 #include <wdmguid.h>
+#include <arc/arc.h>
 #include <ndk/ntndk.h>
 #undef TEXT
 #define TEXT(s) L##s
@@ -23,6 +24,7 @@
 
 /* FIXME: Temporary until CC Ros is gone */
 #include <ccros.h>
+#include <rosldr.h>
 
 /* Disk Dump Driver Header */
 #include <diskdump/diskdump.h>
Index: ntoskrnl/include/internal/kd.h
===================================================================
--- ntoskrnl/include/internal/kd.h	(revision 21808)
+++ ntoskrnl/include/internal/kd.h	(working copy)
@@ -1,10 +1,61 @@
 #ifndef __INCLUDE_INTERNAL_KERNEL_DEBUGGER_H
 #define __INCLUDE_INTERNAL_KERNEL_DEBUGGER_H
 
+//
+// Kernel Debugger Port Definition
+//
+typedef struct _KD_PORT_INFORMATION
+{
+    ULONG ComPort;
+    ULONG BaudRate;
+    ULONG BaseAddress;
+} KD_PORT_INFORMATION, *PKD_PORT_INFORMATION;
+
 struct _KD_DISPATCH_TABLE;
 extern KD_PORT_INFORMATION GdbPortInfo;
 
+BOOLEAN
+NTAPI
+KdPortInitialize(
+    PKD_PORT_INFORMATION PortInformation,
+    ULONG Unknown1,
+    ULONG Unknown2
+);
+
+BOOLEAN
+NTAPI
+KdPortInitializeEx(
+    PKD_PORT_INFORMATION PortInformation,
+    ULONG Unknown1,
+    ULONG Unknown2
+);
+
+BOOLEAN
+NTAPI
+KdPortGetByte(
+    PUCHAR ByteRecieved);
+
+BOOLEAN
+NTAPI
+KdPortGetByteEx(
+    PKD_PORT_INFORMATION PortInformation,
+    PUCHAR ByteRecieved);
+
+VOID
+NTAPI
+KdPortPutByte(
+    UCHAR ByteToSend
+);
+
+VOID
+NTAPI
+KdPortPutByteEx(
+    PKD_PORT_INFORMATION PortInformation,
+    UCHAR ByteToSend
+);
+
 /* SYMBOL ROUTINES **********************************************************/
+#ifdef __NTOSKRNL__
 
 #if defined(KDBG) || defined(DBG)
 
@@ -284,4 +335,5 @@
 /* Whether to enter KDB as early as possible or not */
 extern BOOLEAN KdpEarlyBreak;
 
+#endif
 #endif /* __INCLUDE_INTERNAL_KERNEL_DEBUGGER_H */
Index: ntoskrnl/include/internal/ke.h
===================================================================
--- ntoskrnl/include/internal/ke.h	(revision 21808)
+++ ntoskrnl/include/internal/ke.h	(working copy)
@@ -277,13 +277,6 @@
 
 /* ipi.c ********************************************************************/
 
-BOOLEAN
-STDCALL
-KiIpiServiceRoutine(
-    IN PKTRAP_FRAME TrapFrame,
-    IN struct _KEXCEPTION_FRAME* ExceptionFrame
-);
-
 VOID
 NTAPI
 KiIpiSendRequest(
@@ -291,13 +284,6 @@
     ULONG IpiRequest
 );
 
-VOID   
-NTAPI   
-KeIpiGenericCall(   
-    VOID (STDCALL *WorkerRoutine)(PVOID),   
-    PVOID Argument   
-);   
-
 /* next file ***************************************************************/
 
 VOID 
@@ -714,13 +700,6 @@
 NTAPI
 KiSetSystemTime(PLARGE_INTEGER NewSystemTime);
 
-NTSTATUS 
-STDCALL
-Ke386CallBios(
-    UCHAR Int,
-    PKV86M_REGISTERS Regs
-);
-
 ULONG
 NTAPI
 KeV86Exception(
Index: ntoskrnl/include/internal/ob.h
===================================================================
--- ntoskrnl/include/internal/ob.h	(revision 21808)
+++ ntoskrnl/include/internal/ob.h	(working copy)
@@ -31,8 +31,31 @@
     LARGE_INTEGER CreateTime;
 } SYMLINK_OBJECT, *PSYMLINK_OBJECT;
 
+typedef struct _ROS_OBJECT_HEADER
+{
+    LIST_ENTRY Entry;
+    LONG PointerCount;
+    union
+    {
+        LONG HandleCount;
+        PVOID NextToFree;
+    };
+    POBJECT_TYPE Type;
+    UCHAR NameInfoOffset;
+    UCHAR HandleInfoOffset;
+    UCHAR QuotaInfoOffset;
+    UCHAR Flags;
+    union
+    {
+        POBJECT_CREATE_INFORMATION ObjectCreateInfo;
+        PVOID QuotaBlockCharged;
+    };
+    PSECURITY_DESCRIPTOR SecurityDescriptor;
+    QUAD Body;
+} ROS_OBJECT_HEADER, *PROS_OBJECT_HEADER;
+
 #define BODY_TO_HEADER(objbdy)                                                 \
-  CONTAINING_RECORD((objbdy), OBJECT_HEADER, Body)
+  CONTAINING_RECORD((objbdy), ROS_OBJECT_HEADER, Body)
   
 #define HEADER_TO_OBJECT_NAME(objhdr) ((POBJECT_HEADER_NAME_INFO)              \
   (!(objhdr)->NameInfoOffset ? NULL: ((PCHAR)(objhdr) - (objhdr)->NameInfoOffset)))
@@ -43,7 +66,7 @@
 #define HEADER_TO_CREATOR_INFO(objhdr) ((POBJECT_HEADER_CREATOR_INFO)          \
   (!((objhdr)->Flags & OB_FLAG_CREATOR_INFO) ? NULL: ((PCHAR)(objhdr) - sizeof(OBJECT_HEADER_CREATOR_INFO))))
 
-#define OBJECT_ALLOC_SIZE(ObjectSize) ((ObjectSize)+sizeof(OBJECT_HEADER))
+#define OBJECT_ALLOC_SIZE(ObjectSize) ((ObjectSize)+sizeof(ROS_OBJECT_HEADER))
 
 #define KERNEL_HANDLE_FLAG (1 << ((sizeof(HANDLE) * 8) - 1))
 #define ObIsKernelHandle(Handle, ProcessorMode)                                \
@@ -58,17 +81,41 @@
 extern POBJECT_TYPE ObSymbolicLinkType;
 extern PHANDLE_TABLE ObpKernelHandleTable;
 
+typedef NTSTATUS
+(NTAPI *OB_ROS_CREATE_METHOD)(
+    PVOID ObjectBody,
+    PVOID Parent,
+    PWSTR RemainingPath,
+    struct _OBJECT_ATTRIBUTES* ObjectAttributes
+);
+
+typedef PVOID
+(NTAPI *OB_ROS_FIND_METHOD)(
+    PVOID  WinStaObject,
+    PWSTR  Name,
+    ULONG  Attributes
+);
+
+typedef NTSTATUS
+(NTAPI *OB_ROS_PARSE_METHOD)(
+    PVOID Object,
+    PVOID *NextObject,
+    PUNICODE_STRING FullPath,
+    PWSTR *Path,
+    ULONG Attributes
+);
+
 VOID
 NTAPI
 ObpAddEntryDirectory(
     PDIRECTORY_OBJECT Parent,
-    POBJECT_HEADER Header,
+    PROS_OBJECT_HEADER Header,
     PWSTR Name
 );
 
 VOID
 NTAPI
-ObpRemoveEntryDirectory(POBJECT_HEADER Header);
+ObpRemoveEntryDirectory(PROS_OBJECT_HEADER Header);
 
 VOID
 NTAPI
Index: ntoskrnl/include/internal/i386/ke.h
===================================================================
--- ntoskrnl/include/internal/i386/ke.h	(revision 21808)
+++ ntoskrnl/include/internal/i386/ke.h	(working copy)
@@ -26,7 +26,7 @@
 #define X86_CR4_OSFXSR          0x00000200 /* enable FXSAVE/FXRSTOR instructions */
 #define X86_CR4_OSXMMEXCPT      0x00000400 /* enable #XF exception */
 
-#define X86_FEATURE_TSC         0x00000010 /* time stamp counters are present */
+#define KF_RDTSC                0x00000002 /* time stamp counters are present */
 #define X86_FEATURE_PAE         0x00000040 /* physical address extension is present */
 #define X86_FEATURE_CX8         0x00000100 /* CMPXCHG8B instruction present */
 #define X86_FEATURE_SYSCALL     0x00000800 /* SYSCALL/SYSRET support present */
@@ -51,81 +51,6 @@
 
 #ifndef __ASM__
 
-typedef struct _KIRQ_TRAPFRAME
-{
-   ULONG Magic;
-   ULONG Gs;
-   ULONG Fs;
-   ULONG Es;
-   ULONG Ds;
-   ULONG Eax;
-   ULONG Ecx;
-   ULONG Edx;
-   ULONG Ebx;
-   ULONG Esp;
-   ULONG Ebp;
-   ULONG Esi;
-   ULONG Edi;
-   ULONG Eip;
-   ULONG Cs;
-   ULONG Eflags;
-} KIRQ_TRAPFRAME, *PKIRQ_TRAPFRAME;
-
-/* Emulate cli/sti instructions */
-#define KV86M_EMULATE_CLI_STI          (0x1)
-/* Allow the v86 mode code to access i/o ports */
-#define KV86M_ALLOW_IO_PORT_ACCESS      (0x2)
-
-typedef struct _KV86M_REGISTERS
-{
-    /*
-     * General purpose registers
-     */
-    ULONG Ebp;
-    ULONG Edi;
-    ULONG Esi;
-    ULONG Edx;
-    ULONG Ecx;
-    ULONG Ebx;
-    ULONG Eax;
-    ULONG Ds;
-    ULONG Es;
-    ULONG Fs;
-    ULONG Gs;
-
-    /*
-     * Control registers
-     */
-    ULONG Eip;
-    ULONG Cs;
-    ULONG Eflags;
-    ULONG Esp;
-    ULONG Ss;
-
-    /*
-     * Control structures
-     */
-    ULONG RecoveryAddress;
-    UCHAR RecoveryInstruction[4];
-    ULONG Vif;
-    ULONG Flags;
-    PNTSTATUS PStatus;
-} KV86M_REGISTERS, *PKV86M_REGISTERS;
-
-typedef struct _KV86M_TRAP_FRAME
-{
-    KTRAP_FRAME Tf;
-
-    ULONG SavedExceptionStack;
-
-    /*
-     * These are put on the top of the stack by the routine that entered
-     * v86 mode so the exception handlers can find the control information
-     */
-    struct _KV86M_REGISTERS* regs;
-    ULONG orig_ebp;
-} KV86M_TRAP_FRAME, *PKV86M_TRAP_FRAME;
-
 extern ULONG Ke386CacheAlignment;
 
 struct _KPCR;
Index: ntoskrnl/include/internal/io.h
===================================================================
--- ntoskrnl/include/internal/io.h	(revision 21808)
+++ ntoskrnl/include/internal/io.h	(working copy)
@@ -477,6 +477,7 @@
 STDCALL
 IopQueryNameFile(
     PVOID ObjectBody,
+    IN BOOLEAN HasName,
     POBJECT_NAME_INFORMATION ObjectNameInfo,
     ULONG Length,
     PULONG ReturnLength
@@ -485,8 +486,11 @@
 VOID
 STDCALL
 IopCloseFile(
-    PVOID ObjectBody,
-    ULONG HandleCount
+    IN PEPROCESS Process OPTIONAL,
+    IN PVOID Object,
+    IN ACCESS_MASK GrantedAccess,
+    IN ULONG ProcessHandleCount,
+    IN ULONG SystemHandleCount
 );
 
 /* plugplay.c */
@@ -557,7 +561,7 @@
 VOID 
 FASTCALL
 xHalIoAssignDriveLetters(
-    IN PLOADER_PARAMETER_BLOCK LoaderBlock,
+    IN PROS_LOADER_PARAMETER_BLOCK LoaderBlock,
     IN PSTRING NtDeviceName,
     OUT PUCHAR NtSystemPath,
     OUT PSTRING NtSystemPathString
Index: ntoskrnl/include/internal/mm.h
===================================================================
--- ntoskrnl/include/internal/mm.h	(revision 21808)
+++ ntoskrnl/include/internal/mm.h	(working copy)
@@ -5,6 +5,8 @@
 
 /* TYPES *********************************************************************/
 
+struct _ROS_EPROCESS;
+
 extern ULONG MiFreeSwapPages;
 extern ULONG MiUsedSwapPages;
 extern ULONG MmPagedPoolSize;
@@ -192,7 +194,7 @@
     PMM_SECTION_SEGMENT Segments;
 } MM_IMAGE_SECTION_OBJECT, *PMM_IMAGE_SECTION_OBJECT;
 
-typedef struct _SECTION_OBJECT
+typedef struct _ROS_SECTION_OBJECT
 {
     CSHORT Type;
     CSHORT Size;
@@ -205,7 +207,7 @@
         PMM_IMAGE_SECTION_OBJECT ImageSection;
         PMM_SECTION_SEGMENT Segment;
     };
-} SECTION_OBJECT, *PSECTION_OBJECT;
+} ROS_SECTION_OBJECT, *PROS_SECTION_OBJECT;
 
 typedef struct _MEMORY_AREA
 {
@@ -224,7 +226,7 @@
     {
         struct
         {
-            SECTION_OBJECT* Section;
+            ROS_SECTION_OBJECT* Section;
             ULONG ViewOffset;
             PMM_SECTION_SEGMENT Segment;
             BOOLEAN WriteCopyView;
@@ -237,17 +239,15 @@
     } Data;
 } MEMORY_AREA, *PMEMORY_AREA;
 
-#ifndef _MMTYPES_H
 typedef struct _MADDRESS_SPACE
 {
     PMEMORY_AREA MemoryAreaRoot;
     FAST_MUTEX Lock;
     PVOID LowestAddress;
-    struct _EPROCESS* Process;
+    struct _ROS_EPROCESS* Process;
     PUSHORT PageTableRefCountTable;
     ULONG PageTableRefCountTableSize;
 } MADDRESS_SPACE, *PMADDRESS_SPACE;
-#endif
 
 typedef struct
 {
@@ -362,7 +362,7 @@
 NTSTATUS
 NTAPI
 MmInitializeAddressSpace(
-    struct _EPROCESS* Process,
+    struct _ROS_EPROCESS* Process,
     PMADDRESS_SPACE AddressSpace);
 
 NTSTATUS
@@ -445,7 +445,7 @@
 VOID
 STDCALL
 MmReleaseMemoryAreaIfDecommitted(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PMADDRESS_SPACE AddressSpace,
     PVOID BaseAddress
 );
@@ -621,18 +621,18 @@
 NTSTATUS
 STDCALL
 MmCreateProcessAddressSpace(
-    IN struct _EPROCESS* Process,
-    IN PSECTION_OBJECT Section OPTIONAL
+    IN struct _ROS_EPROCESS* Process,
+    IN PROS_SECTION_OBJECT Section OPTIONAL
 );
 
 NTSTATUS
 STDCALL
-MmCreatePeb(PEPROCESS Process);
+MmCreatePeb(struct _ROS_EPROCESS *Process);
 
 struct _TEB*
 STDCALL
 MmCreateTeb(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PCLIENT_ID ClientId,
     PINITIAL_TEB InitialTeb
 );
@@ -640,7 +640,7 @@
 VOID
 STDCALL
 MmDeleteTeb(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     struct _TEB* Teb
 );
 
@@ -706,7 +706,7 @@
 VOID
 NTAPI
 MmFreeVirtualMemory(
-    struct _EPROCESS* Process,
+    struct _ROS_EPROCESS* Process,
     PMEMORY_AREA MemoryArea
 );
 
@@ -860,7 +860,7 @@
 NTAPI
 MmInsertRmap(
     PFN_TYPE Page,
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address
 );
 
@@ -869,14 +869,14 @@
 MmDeleteAllRmaps(
     PFN_TYPE Page,
     PVOID Context,
-    VOID (*DeleteMapping)(PVOID Context, PEPROCESS Process, PVOID Address)
+    VOID (*DeleteMapping)(PVOID Context, struct _ROS_EPROCESS *Process, PVOID Address)
 );
 
 VOID
 NTAPI
 MmDeleteRmap(
     PFN_TYPE Page,
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address
 );
 
@@ -994,7 +994,7 @@
 NTSTATUS
 NTAPI
 MmCreateVirtualMapping(
-    struct _EPROCESS* Process,
+    struct _ROS_EPROCESS* Process,
     PVOID Address,
     ULONG flProtect,
     PPFN_TYPE Pages,
@@ -1004,7 +1004,7 @@
 NTSTATUS
 NTAPI
 MmCreateVirtualMappingUnsafe(
-    struct _EPROCESS* Process,
+    struct _ROS_EPROCESS* Process,
     PVOID Address,
     ULONG flProtect,
     PPFN_TYPE Pages,
@@ -1014,13 +1014,13 @@
 ULONG
 NTAPI
 MmGetPageProtect(
-    struct _EPROCESS* Process,
+    struct _ROS_EPROCESS* Process,
     PVOID Address);
 
 VOID
 NTAPI
 MmSetPageProtect(
-    struct _EPROCESS* Process,
+    struct _ROS_EPROCESS* Process,
     PVOID Address,
     ULONG flProtect
 );
@@ -1028,7 +1028,7 @@
 BOOLEAN
 NTAPI
 MmIsPagePresent(
-    struct _EPROCESS* Process,
+    struct _ROS_EPROCESS* Process,
     PVOID Address
 );
 
@@ -1039,7 +1039,7 @@
 VOID
 NTAPI
 MmDisableVirtualMapping(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address,
     BOOLEAN* WasDirty,
     PPFN_TYPE Page
@@ -1048,7 +1048,7 @@
 VOID
 NTAPI
 MmEnableVirtualMapping(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address
 );
 
@@ -1059,7 +1059,7 @@
 VOID
 NTAPI
 MmDeletePageFileMapping(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address,
     SWAPENTRY* SwapEntry
 );
@@ -1067,7 +1067,7 @@
 NTSTATUS
 NTAPI
 MmCreatePageFileMapping(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address,
     SWAPENTRY SwapEntry
 );
@@ -1075,7 +1075,7 @@
 BOOLEAN
 NTAPI
 MmIsPageSwapEntry(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address
 );
 
@@ -1089,7 +1089,7 @@
 VOID
 NTAPI
 MmSetDirtyPage(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address
 );
 
@@ -1125,7 +1125,7 @@
 BOOLEAN
 NTAPI
 MmIsAccessedAndResetAccessPage(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address
 );
 
@@ -1160,7 +1160,7 @@
 VOID
 NTAPI
 MmSetCleanPage(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address
 );
 
@@ -1171,37 +1171,37 @@
 VOID
 NTAPI
 MmDeletePageTable(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address
 );
 
 PFN_TYPE
 NTAPI
 MmGetPfnForProcess(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address
 );
 
 NTSTATUS
 STDCALL
 MmCopyMmInfo(
-    PEPROCESS Src,
-    PEPROCESS Dest,
+    struct _ROS_EPROCESS *Src,
+    struct _ROS_EPROCESS *Dest,
     PPHYSICAL_ADDRESS DirectoryTableBase
 );
 
 NTSTATUS
 NTAPI
-MmReleaseMmInfo(PEPROCESS Process);
+MmReleaseMmInfo(struct _ROS_EPROCESS *Process);
 
 NTSTATUS
 NTAPI
-Mmi386ReleaseMmInfo(PEPROCESS Process);
+Mmi386ReleaseMmInfo(struct _ROS_EPROCESS *Process);
 
 VOID
 NTAPI
 MmDeleteVirtualMapping(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address,
     BOOLEAN FreePage,
     BOOLEAN* WasDirty,
@@ -1211,7 +1211,7 @@
 BOOLEAN
 NTAPI
 MmIsDirtyPage(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address
 );
 
@@ -1226,7 +1226,7 @@
 VOID
 NTAPI
 MmUpdatePageDir(
-    PEPROCESS Process,
+    struct _ROS_EPROCESS *Process,
     PVOID Address,
     ULONG Size
 );
@@ -1301,21 +1301,6 @@
 
 NTSTATUS
 NTAPI
-MmMapViewOfSection(
-    IN PVOID SectionObject,
-    IN PEPROCESS Process,
-    IN OUT PVOID *BaseAddress,
-    IN ULONG ZeroBits,
-    IN ULONG CommitSize,
-    IN OUT PLARGE_INTEGER SectionOffset OPTIONAL,
-    IN OUT PULONG ViewSize,
-    IN SECTION_INHERIT InheritDisposition,
-    IN ULONG AllocationType,
-    IN ULONG Protect
-);
-
-NTSTATUS
-NTAPI
 MmProtectSectionView(
     PMADDRESS_SPACE AddressSpace,
     PMEMORY_AREA MemoryArea,
